-- table of block textures
BLOCK_TEXTURES = {
	love.graphics.newImage("res/blocks/stone.png"),
}

-- make sure all the textures in BLOCK_TEXTURES stay pixely even when scaled
for i = 1, #BLOCK_TEXTURES do
	BLOCK_TEXTURES[i]:setFilter("nearest", "nearest")
end
	
-- these globals serve the double purpose of identifying the block type and
-- determining which texture to use from the BLOCK_TEXTURES table, an enumeration
-- would have been nice right about now . . .
PLAYER = 0
BLOCK_CORE = 1
SENSOR_CORE = 100
SENSOR_MOUSE = 99

--[[

Base class for all blocks in the game

]]

Block = class("Block", Actor)
	
function Block:initialize(x, y, w, h, world, type)

	self.type = type
	self.w = w
	self.h = h
	
	Actor.initialize(self, x, y, w*4, h*4, world)
	
	self.fixture:setUserData({
		parent = self, 
		}) 
	
	local xPoint = math.random(0, BLOCK_TEXTURES[1]:getWidth()-self.w)
	local yPoint = math.random(0, BLOCK_TEXTURES[1]:getHeight()-self.h)
	self.quad = love.graphics.newQuad(xPoint, yPoint, self.w, self.h, BLOCK_TEXTURES[1]:getWidth(), BLOCK_TEXTURES[1]:getHeight()) 
		

end

function Block:update(dt)

	Actor.update(self, dt)

end

function Block:draw()

	Actor.draw(self)
	
	love.graphics.drawq( BLOCK_TEXTURES[1], self.quad, self.x, self.y, self.body:getAngle(), 1 + .5/self.w, 1 + .5/self.h, self.w/2, self.h/2)
	

end

function Block:beginContact(fixture, coll)


end

function Block:endContact(fixture, coll)
    
end

function Block:preSolve(fixture, coll)
    
end

function Block:postSolve(fixture, coll)
    
end